#ifndef OneByOneSupportCounterANDTransactionFiltering_HPP
#define OneByOneSupportCounterANDTransactionFiltering_HPP

#include "common.hpp"
#include <vector>
//#include <cstdio>
//#include <iterator>	//for test



/** OnyByOneSupportCounterANDTransactionFiltering treats transactions individually, i.e. 
    it reads the transactions one by one and calls the support count 
    method for each of them.
 */

template <class DATA_STRUCTURE, class TR, class SC = Dummy>
class OneByOneSupportCounterANDTransactionFiltering
{
   private:

      DATA_STRUCTURE& data_structure;
      TR& transaction_reader;
      SC support_counter;

   public:
      OneByOneSupportCounterANDTransactionFiltering( DATA_STRUCTURE& data_structure,
						     TR& transaction_reader) :
	 data_structure(data_structure), 
	 transaction_reader(transaction_reader){}
      void countSupport(const unsigned int candidate_size);      
};

template <class DATA_STRUCTURE, class TR, class SC> inline void 
OneByOneSupportCounterANDTransactionFiltering<DATA_STRUCTURE, TR, SC>::
countSupport(const unsigned int candidate_size )
{
   assert( candidate_size > 2 );
   transaction_reader.rewind();
   transaction_reader.setCandidateSize(candidate_size);
   std::vector<unsigned int> filter(transaction_reader.getLargestItem() + 1, 0);
   std::vector<item_t> transaction;
   counter_t multiplicity;
   if( (multiplicity = transaction_reader.nextTransactionBIS(
	      transaction)) !=0)
   {
      support_counter.updateCounters(
	 data_structure, transaction, 
	 candidate_size, multiplicity, filter);
      while( (multiplicity = transaction_reader.nextTransactionBIS_modifyPrevious(
		 transaction, filter)) !=0 )
      {
	 support_counter.updateCounters(
	    data_structure, transaction, 
	    candidate_size, multiplicity, filter);
      }
   }


}
#endif
