/*!
  \file   io/db_cache/transaction_shrinker/RBTreeDBCacheInsertThenDestroySimple.hpp
  \brief  An efficient database cacher that enables transaction shrinking.

  \author Ferenc BODON
  \date   2006-05-04
*/
#ifndef RBTreeDBCacheInsertThenDestroyPro_HPP
#define RBTreeDBCacheInsertThenDestroyPro_HPP

#include <vector>
#include <map>
#include "io/db_cache/transaction_shrinker/RBTreeDBCacheInsertThenDestroyBase.hpp"
//#include <fstream>

namespace Bodon
{
/**
   An efficient database cacher that enables transaction shrinking.

   This class makes use of the fact that both trees are sorted
   associative containers and performs the merge with a simultaneous
   traversal approach.
*/
   template< class T_R, class BIS = std::vector<item_t> >
   class RBTreeDBCacheInsertThenDestroyPro : 
	 public RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>
   {
      public:
	 typedef typename RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>
	 ::params_t params_t;

	 RBTreeDBCacheInsertThenDestroyPro( const params_t* par )
	    : RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>(par){}


	 void rewind()
	 {
	    typename std::map<BIS, counter_t>::const_iterator it_temp = 
	       RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::temp_rb_tree.begin();

	    typename std::map<BIS, counter_t>::iterator it_large = 
	       RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::rb_tree.begin();
	    typename std::map<BIS, counter_t>::iterator it_temp_large;

	    while( it_temp != RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::temp_rb_tree.end() &&  
		   it_large != RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::rb_tree.end() )
	    {
	       if(it_temp->first < it_large->first)
	       {
		  RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::
		     rb_tree[it_temp->first] = it_temp->second;
// GRRRR!!!   Why does not compile this code ?!?
// 		  --it_large;
// 		  it_temp_large = RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::
// 		     rb_tree.insert(it_large, it_temp->first);
// 		  ++it_large;
// 		  it_temp_large->second = it_temp->second;
		  ++it_temp;

	       }
	       else if(it_temp->first > it_large->first)
		  ++it_large;
	       else
	       {
		  it_large->second += it_temp->second;		  
		  ++it_temp;
		  ++it_large;
	       }
	    }
	    while( it_temp != RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::
		   temp_rb_tree.end() )
	    {
	       RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::
		  rb_tree[it_temp->first] = it_temp->second; //we should use insert with hint!!!
	       ++it_temp;
	    }
	    RBTreeDBCacheInsertThenDestroyBase<T_R, BIS>::rewind();
	 }
   };

}
#endif
