#ifndef SimpleAssocRuleWriter_HPP
#define SimpleAssocRuleWriter_HPP

/**
 *@author Ferenc Bodon
 */

#include <iterator>
#include "io/StreamRepr.hpp"  
#include "io/codec/decoder/df/SimpleDFDecoder.hpp"  



class SimpleAssocRuleWriter : public SimpleDFDecoder< BufferedNormalOutput<StreamRepr> >
{
   protected:
      typedef SimpleDFDecoder< BufferedNormalOutput<StreamRepr> > PARENT;
   public:
      typedef PARENT::params_t params_t;

      SimpleAssocRuleWriter(const params_t* par) : 
	 PARENT(par) {}

      template <typename ANTECIterator, typename CONSEQIterator> void 
      writeAssocRule(
	 ANTECIterator antec_first, ANTECIterator antec_last, 
	 CONSEQIterator conseq_first, CONSEQIterator conseq_last, 
	 counter_t union_support, float confidence, float lift )
      {
	 while( antec_first != antec_last)
	 {
	    PARENT::output_stream << PARENT::code_inverse[*antec_first] << ' ';
	    ++antec_first;
	 }
	 PARENT::output_stream<<"-> ";
	 while( conseq_first != conseq_last)
	 {
	    PARENT::output_stream << PARENT::code_inverse[*conseq_first] << ' ';
	    ++conseq_first;
	 }
	 PARENT::output_stream<<'(' << union_support <<' '<< confidence << ' '<<lift<<")\n";
      }
};

#endif

